# $LynxId: makefile.in,v 1.77 2021/02/28 15:56:53 tom Exp $
# template-makefile for Lynx src directory

SHELL		= sh
CDPATH		= .


prefix		= /dev/env/DJDIR
datarootdir	= ${prefix}/share
exec_prefix	= ${prefix}
top_srcdir	= .././..
srcdir		= .././../src
VPATH		= .;$(srcdir)

top_builddir	= ..

# see po/makefile
localedir	= /dev/env/DJDIR/share/locale

# Symbols which the configure script can set in each makefile:
CC		= gcc
CPP		= gcc -E -C
CFLAGS		= -g2 -O2 -std=gnu99 -march=i386 -mtune=i586  
DEFS		= -DHAVE_CONFIG_H
CHARSET_DEFS	= 
CPPFLAGS	= -I/dev/env/WATT_ROOT/inc -I/dev/env/DJDIR/include -D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=199506L -DDOSPATH -DNOUSERS -I/dev/env/DJDIR/lib/../include -I/dev/env/DJDIR/include/openssl

x		= .exe
o		= .o

BUILD_CC	= ${CC}
BUILD_CPP	= ${CPP}
BUILD_CFLAGS	= ${CFLAGS}
BUILD_CPPFLAGS	= ${CPPFLAGS} -DHAVE_CONFIG_H
BUILD_EXEEXT	= $x
BUILD_LDFLAGS	= ${LDFLAGS}
BUILD_LIBS	= ${LIBS}

MAKE_RECUR	= $(MAKE)  DESTDIR="$(DESTDIR)" CC="$(CC)"

YACC		= byacc
WINDRES		= none

LIBS		= -lz -lbz2 -lidn -liconv -liconv -lpdcurses -lssl -lcrypto -L/dev/env/WATT_ROOT/lib -lssl -lcrypto -lwatt -lz -lwatt $(RESOLVLIB) $(WAISLIB) $(SITE_LIBS)
LDFLAGS		=  -L/dev/env/DJDIR/lib 

# Symbols inherited from the top-level makefile
RESOLVLIB	= # FIXME: set in parent makefile
SITE_DEFS	= # FIXME: set in parent makefile
SITE_LIBS	= # FIXME: set in parent makefile
WAISLIB		= # FIXME: set in parent makefile

WWWINC		= WWW/Library/Implementation
WWWLIB		= $(top_builddir)/WWW/Library/Implementation/libwww.a

INTLLIB		= 
INTLDIR_CPPFLAGS= #-I$(top_srcdir)/intl

CPP_OPTS	= $(DEFS) $(CHARSET_DEFS) \
		-DLOCALEDIR=\"$(localedir)\" \
		-I. \
		-I$(top_builddir) \
		-Ichrtrans \
		-I$(srcdir)/chrtrans \
		-I$(top_srcdir) \
		-I$(top_srcdir)/src \
		-I$(top_srcdir)/$(WWWINC) \
		$(INTLDIR_CPPFLAGS) $(SITE_DEFS) $(CPPFLAGS)
CC_OPTS		= $(CFLAGS) $(CPP_OPTS)

LINT		= 
LINTOPTS	=

CTAGS		= 

COMPRESS_PROG	=
COMPRESS_EXT	=

CHARTRANS_OBJS	= UCdomap$o UCAux$o UCAuto$o
OBJS		= \
	LYebcdic$o \
	LYClean$o LYShowInfo$o LYEdit$o LYStrings$o LYMail$o \
	HTAlert$o GridText$o LYGetFile$o LYMain$o LYMainLoop$o \
	LYCurses$o LYBookmark$o LYmktime$o LYUtils$o LYOptions$o \
	LYReadCFG$o LYSearch$o LYHistory$o LYForms$o LYPrint$o \
	LYrcFile$o LYDownload$o LYNews$o LYKeymap$o HTML$o \
	HTFWriter$o HTInit$o DefaultStyle$o LYUpload$o \
	LYLeaks$o LYexit$o LYJump$o LYList$o LYCgi$o \
	LYTraversal$o LYEditmap$o LYCharSets$o LYCharUtils$o \
	LYMap$o LYCookie$o LYStyle$o LYHash$o LYPrettySrc$o \
	TRSTable$o parsdate$o $(CHARTRANS_OBJS)  LYSession$o LYExtern$o LYLocal$o  wcwidth.o

C_SRC		= $(OBJS:$o=.c)

all: lynx$x

.SUFFIXES : $o .i

# yacc builds .c in target directory, not $(srcdir)
.c$o:
	
	$(CC) $(CC_OPTS) -c $<

.c.i:
	
	$(CPP) $(CPP_OPTS) $< >$@

lynx$x:   message $(top_builddir)/LYHelp.h $(OBJS) $(WWWLIB)
	@echo "Linking and creating Lynx executable"
	$(CC) $(CC_OPTS) $(LDFLAGS) -o $@  $(OBJS) $(WWWLIB) $(LIBS) $(INTLLIB)
	@echo "Copying Lynx executable into top-level directory"
	rm -f $(top_builddir)/$@
	cp $@ $(top_builddir)/
	@echo "Welcome to Lynx!"

message:
	@echo "Compiling Lynx sources"

do_chartrans_stuff:
	-( cd chrtrans && $(MAKE_RECUR) \
		SITE_DEFS="$(SITE_DEFS)" \
		BUILD_CFLAGS="$(BUILD_CFLAGS)" \
		BUILD_CPPFLAGS="$(BUILD_CPPFLAGS)" \
		BUILD_LDFLAGS="$(BUILD_LDFLAGS)" \
		BUILD_LIBS="$(BUILD_LIBS)" \
		BUILD_CC="$(BUILD_CC)" tables )

lint:
	$(LINT) $(LINTOPTS) $(CPP_OPTS) $(C_SRC)  2>&1 |tee $(top_builddir)/lint.lynx

clean:
	rm -f lynx$x core *.core *.leaks *.i *$o *.bak tags TAGS test_*
	( cd chrtrans && $(MAKE_RECUR) clean )

tags:
	$(CTAGS) *.[ch]

distclean: clean

CMN=$(top_srcdir)/WWW/Library/Implementation/

GridText$o :		$(top_srcdir)/userdefs.h
HTFWriter$o :		$(top_srcdir)/userdefs.h
HTInit$o :		$(top_srcdir)/userdefs.h
LYCharSets$o :		$(top_srcdir)/userdefs.h
LYGetFile$o :		$(top_srcdir)/userdefs.h
LYKeymap$o :		$(top_srcdir)/userdefs.h
LYLeaks$o :		$(CMN)LYLeaks.h $(CMN)HTString.h
LYMail$o :		$(top_srcdir)/userdefs.h
LYMain$o :		$(top_srcdir)/userdefs.h $(top_builddir)/lynx_cfg.h
LYMainLoop$o :		$(top_srcdir)/userdefs.h
LYOptions$o :		$(top_srcdir)/userdefs.h
LYReadCFG$o :		$(top_srcdir)/userdefs.h
LYShowInfo$o :		$(top_builddir)/cfg_defs.h
LYTraversal$o :		$(top_srcdir)/userdefs.h
LYUtils$o :		$(top_srcdir)/userdefs.h
LYmktime$o :		$(top_srcdir)/userdefs.h
LYrcFile$o :		$(top_srcdir)/userdefs.h

LYIcon$o: LYIcon.rc
	$(WINDRES) -i LYIcon.rc -o LYIcon$o -O coff

CHRTR= chrtrans/

TABLES= \
 $(CHRTR)cp1250_uni.h \
 $(CHRTR)cp1251_uni.h \
 $(CHRTR)cp1252_uni.h \
 $(CHRTR)cp1253_uni.h \
 $(CHRTR)cp1255_uni.h \
 $(CHRTR)cp1256_uni.h \
 $(CHRTR)cp1257_uni.h \
 $(CHRTR)cp437_uni.h \
 $(CHRTR)cp737_uni.h \
 $(CHRTR)cp775_uni.h \
 $(CHRTR)cp850_uni.h \
 $(CHRTR)cp852_uni.h \
 $(CHRTR)cp857_uni.h \
 $(CHRTR)cp862_uni.h \
 $(CHRTR)cp864_uni.h \
 $(CHRTR)cp866_uni.h \
 $(CHRTR)cp866u_uni.h \
 $(CHRTR)cp869_uni.h \
 $(CHRTR)def7_uni.h \
 $(CHRTR)dmcs_uni.h \
 $(CHRTR)hp_uni.h \
 $(CHRTR)iso01_uni.h \
 $(CHRTR)iso02_uni.h \
 $(CHRTR)iso03_uni.h \
 $(CHRTR)iso04_uni.h \
 $(CHRTR)iso05_uni.h \
 $(CHRTR)iso06_uni.h \
 $(CHRTR)iso07_uni.h \
 $(CHRTR)iso08_uni.h \
 $(CHRTR)iso09_uni.h \
 $(CHRTR)iso10_uni.h \
 $(CHRTR)iso13_uni.h \
 $(CHRTR)iso14_uni.h \
 $(CHRTR)iso15_uni.h \
 $(CHRTR)koi8r_uni.h \
 $(CHRTR)koi8u_uni.h \
 $(CHRTR)mac_uni.h \
 $(CHRTR)mnem2_suni.h \
 $(CHRTR)mnem_suni.h \
 $(CHRTR)next_uni.h \
 $(CHRTR)pt154_uni.h \
 $(CHRTR)rfc_suni.h \
 $(CHRTR)utf8_uni.h \
 $(CHRTR)viscii_uni.h

$(TABLES):
	-( cd chrtrans && $(MAKE_RECUR) tables )

UCdomap$o :	UCdomap.c \
		chrtrans/UCkd.h \
		chrtrans/makeuctb$(BUILD_EXEEXT) \
		chrtrans/makeuctb.c \
	UCdomap.h $(CMN)UCMap.h $(TABLES) $(top_srcdir)/userdefs.h

chrtrans/makeuctb$(BUILD_EXEEXT):
	( cd chrtrans && $(MAKE_RECUR) makeuctb$(BUILD_EXEEXT) )

UCAux$o : UCAux.c $(CMN)UCAux.h $(CMN)UCDefs.h
LYCookie$o : $(top_srcdir)/userdefs.h

test_mktime.o: $(srcdir)/LYmktime.c
	$(CC) -o $@ $(CC_OPTS) -DTEST_DRIVER -c $(srcdir)/LYmktime.c

# test-driver for LYmktime
test_mktime: test_mktime.o parsdate.o LYebcdic.o
	$(CC) -o $@ $(CC_OPTS) test_mktime.o parsdate.o LYebcdic.o

# update generated source (may be in ".", or srcdir)
parsdate.c : $(srcdir)/parsdate.y
	$(YACC)  $(srcdir)/parsdate.y
	-rm -f $@
	mv y_tab.c $@

depend : $(TABLES)
	makedepend -fmakefile -- $(CC_OPTS) -- $(C_SRC)

# DO NOT DELETE THIS LINE -- make depend depends on it.
